import _extends from "@babel/runtime/helpers/esm/extends";
import { forwardRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import AtomLabel from '@s-ui/react-atom-label';
import { suitClass, switchClassNames } from './helpers.js';
import { LABELS, TYPES } from '../config.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var RIGHT = LABELS.RIGHT,
    LEFT = LABELS.LEFT;
export var SingleSwitchTypeRender = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _cx, _cx2;

  var disabled = _ref.disabled,
      isFitted = _ref.isFitted,
      label = _ref.label,
      labelLeft = _ref.labelLeft,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      labelOptionalText = _ref.labelOptionalText,
      labelRight = _ref.labelRight,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onToggle = _ref.onToggle,
      size = _ref.size,
      type = _ref.type,
      value = _ref.value,
      fullWidth = _ref.fullWidth,
      isChecked = _ref.isChecked;
  var defaultLabelLeft = labelLeft === LEFT;
  var defaultLabelRight = labelRight === RIGHT;
  var showLabelLeft = Boolean(label) || !defaultLabelLeft;
  var showLabelRight = !label && !defaultLabelRight && defaultLabelLeft;
  return /*#__PURE__*/_jsx("div", {
    className: switchClassNames({
      size: size,
      classType: 'singleType',
      fullWidth: fullWidth
    }),
    children: /*#__PURE__*/_jsxs("div", {
      className: cx(suitClass({
        element: 'container'
      }), (_cx = {}, _cx[suitClass({
        element: 'container--isFitted'
      })] = isFitted, _cx[suitClass({
        element: 'container--fullWidth'
      })] = fullWidth, _cx)),
      onFocus: onFocus,
      onBlur: onBlur,
      ref: ref,
      children: [showLabelLeft && /*#__PURE__*/_jsx(AtomLabel, {
        name: name,
        text: defaultLabelLeft ? label : labelLeft,
        optionalText: labelOptionalText
      }), /*#__PURE__*/_jsxs("button", _extends({
        type: "button",
        className: cx(suitClass({
          element: 'inputContainer'
        }), (_cx2 = {}, _cx2[suitClass({
          element: 'inputContainer',
          modifier: 'right'
        })] = isChecked, _cx2)),
        role: "switch",
        onClick: onToggle(),
        "aria-checked": isChecked || type === TYPES.SELECT,
        "aria-disabled": disabled,
        disabled: disabled,
        id: name
      }, !disabled && {
        tabIndex: 0
      }, {
        children: [/*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'icon-left'
          })),
          children: iconLeft
        }), /*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'circle'
          }))
        }), /*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'icon-right'
          })),
          children: iconRight
        })]
      })), showLabelRight && /*#__PURE__*/_jsx(AtomLabel, {
        name: name,
        text: labelRight,
        optionalText: labelOptionalText
      })]
    })
  });
});
SingleSwitchTypeRender.displayName = 'SingleSwitchTypeRender';