import _extends from "@babel/runtime/helpers/esm/extends";
import { useState, forwardRef } from 'react';
import PropTypes from 'prop-types';
import { ToggleSwitchTypeRender } from './SwitchType/toggle.js';
import { SingleSwitchTypeRender } from './SwitchType/single.js';
import { LABELS, SIZES, TYPES } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AtomSwitch = /*#__PURE__*/forwardRef(function (props, ref) {
  var initialValue = props.initialValue,
      onToggleCallback = props.onToggle,
      type = props.type,
      value = props.value;

  var _useState = useState(initialValue),
      isToggle = _useState[0],
      setIsToggle = _useState[1];

  var isChecked = value !== undefined ? value : isToggle;

  var onToggle = function onToggle(forcedValue) {
    return function (event) {
      var newIsToggle = forcedValue !== undefined ? forcedValue : !isToggle;

      if (props.value === undefined) {
        // if its uncontrolled component
        setIsToggle(newIsToggle);
      } else {
        newIsToggle = !props.value;
      }

      typeof onToggleCallback === 'function' && onToggleCallback(newIsToggle);
    };
  };

  var commonProps = _extends({}, props, {
    isToggle: isToggle,
    isChecked: isChecked,
    onToggle: onToggle,
    value: value
  });

  return type === TYPES.SINGLE ? /*#__PURE__*/_jsx(SingleSwitchTypeRender, _extends({
    ref: ref
  }, commonProps)) : /*#__PURE__*/_jsx(ToggleSwitchTypeRender, _extends({
    ref: ref
  }, commonProps));
});
AtomSwitch.displayName = 'AtomSwitch';
AtomSwitch.defaultProps = {
  disabled: false,
  isFitted: false,
  initialValue: false,
  labelLeft: LABELS.LEFT,
  labelRight: LABELS.RIGHT,
  size: SIZES.DEFAULT,
  type: TYPES.TOGGLE
};
export { SIZES as atomSwitchSizes };
export { TYPES as atomSwitchTypes };
export default AtomSwitch;